<template>
  <el-dropdown id="namedisplayAndMenu">
    <div
      class="flex items-center mx-2 font-bold cursor-pointer --text3 dropdown-list-menu gap-1"
    >
      <div>
        {{ username }}
      </div>
      <MessagesMessageCount
        v-if="unreadInfo.TotalCount"
        :count="unreadInfo.TotalCount"
        :is-unread="true"
        class="!ml-0"
        is-redirect
      ></MessagesMessageCount>
      <svg-icon svg-name="arrow-fill-down" class="dropdown-icon w-4 h-4"></svg-icon>
    </div>
    <template #dropdown>
      <div>
        <el-dropdown-menu class="px-1 --text3 bg-background1">
          <nuxt-link
            v-if="isShowDepositWithdrawal && isCashPlayer"
            to="/deposit"
          >
            <el-dropdown-item>
              <div id="dropdownDepositOption">{{ $t(`deposit${isBhinbhin}`) }}</div>
            </el-dropdown-item>
          </nuxt-link>
          <nuxt-link
            v-if="isShowDepositWithdrawal && isCashPlayer"
            to="/withdrawal"
          >
            <el-dropdown-item>
              <div id="dropdownWithdrawalOption">{{ $t("withdrawal") }}</div>
            </el-dropdown-item>
          </nuxt-link>
          <nuxt-link to="/wallet">
            <el-dropdown-item>
              <div id="dropdownWalletOption">{{ $t("wallet") }}</div>
            </el-dropdown-item>
          </nuxt-link>
          <nuxt-link :to="ROUTES.ACCOUNT.INFO">
            <el-dropdown-item>
              <div id="dropdownAccountOption">{{ $t("account") }}</div>
            </el-dropdown-item>
          </nuxt-link>
          <nuxt-link to="/transaction-history">
            <el-dropdown-item>
              <div id="dropdownStatementOption">{{ $t("statement") }}</div>
            </el-dropdown-item>
          </nuxt-link>
          <nuxt-link :to="BET_HISTORY_ROUTES.INDEX">
            <el-dropdown-item>
              <div id="dropdownBetHistoryOption">{{ $t("bet_history") }}</div>
            </el-dropdown-item>
          </nuxt-link>
          <nuxt-link to="/my-promotion" v-if="isShowPromotion">
            <el-dropdown-item>
              <div id="dropdownPromotionOption">{{ $t("promotion") }}</div>
            </el-dropdown-item>
          </nuxt-link>
          <nuxt-link v-if="referralEnabled && !isV2ReferralEnabled" to="/referral/referral">
            <el-dropdown-item >{{ $t("referral") }}</el-dropdown-item>
          </nuxt-link>
          <nuxt-link v-if="isReferralV2Enabled && isShowReferralPage" to="/referral-v2/information">
            <el-dropdown-item id="dropdownReferralOption">{{ $t("referral") }}</el-dropdown-item>
          </nuxt-link>
          <nuxt-link to="/messages">
            <el-dropdown-item>
              <div id="dropdownMessageOption" class="flex items-center gap-[25px]">
                {{ $t("messages") }}
                <MessagesMessageCount
                  v-if="unreadInfo && unreadInfo.TotalCount"
                  :count="unreadInfo.TotalCount"
                  :is-unread="true"
                  class="!ml-0"
                ></MessagesMessageCount>
              </div>
            </el-dropdown-item>
          </nuxt-link>
          <el-dropdown-item class="group" @click="logout">
            <div id="dropdownSignOutOption" class="text-red-600 group-focus:text-white">
              {{ $t("logout") }}
            </div>
          </el-dropdown-item>
        </el-dropdown-menu>
      </div>
    </template>
  </el-dropdown>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { store } from "~~/store";

export default defineComponent({
  name: "ProfileInformationComponent",
  props: {
    username: {
      type: String,
      require: true,
    },
    referralEnabled: {
      type: Boolean,
      require: true,
    },
    isReferralV2Enabled: {
      type: Boolean,
      require: true,
    },
    isShowDepositWithdrawal: {
      type: Boolean,
      require: true,
    },
    isCashPlayer: {
      type: Boolean,
      require: true,
    },
    logout: {
      type: Function,
      require: true,
    },
  },
  setup() {
    const { isShowPromotion } = useMenu();
    const isV2ReferralEnabled = computed(() => store.state.isV2ReferralEnabled);
    const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
    const isCashPlayer = computed(() => store.state.isCashPlayer);
    const { fetchMessages, unreadInfo } = useMessage();
    const { isBhinbhin } = commonHelper;
    const route = useRoute();

    onMounted(() => {
      if (!route.fullPath.includes("messages")) {
        fetchMessages();
      }
    });
    return {
      isShowPromotion,
      isV2ReferralEnabled,
      isCashPlayer,
      isShowReferralPage,
      unreadInfo,
      isBhinbhin,
    };
  },
});
</script>
<style scoped>
:deep(.el-dropdown-menu__item) {
  --el-dropdown-menuItem-hover-fill: var(--primary);
  --el-dropdown-menuItem-hover-color: #fff;
  padding: 8px;
  color: var(--text);
}

:deep(.dropdown-icon) {
  fill: var(--text3);
}

:deep(.el-dropdown-menu) {
  border-radius: 3px;
}
</style>
